
/*
*  crc32.h
*   Author  : sky(shu)
*   License : NYSL
*/

#ifndef CRC32_H_INCLUDED_
#define CRC32_H_INCLUDED_


static unsigned int crc32( unsigned char *buf, int len )
{
	unsigned int crc_table[256];
	int crc_table_computed = 0;

	unsigned int c;
	int n, k;

	// 
	for( n = 0; n < 256; n++ ){
		c = (unsigned int)n;
			for( k = 0; k < 8; k++ ){
				if( c & 1 ){
					c = 0xedb88320L ^ (c >> 1);
				}else{
					c = c >> 1;
				}
		}
		crc_table[n] = c;
	}

	// vZ
	c = 0xFFFFFFFFL;
	for( n = 0; n < len; n++ ){
		c = crc_table[(c ^ buf[n]) & 0xff] ^ (c >> 8);
	}
	return c;
}

#endif
